struct Vertex 
{
  string mName;
  float x, z, bringforward;
  int degree;
  int refinedtype;
};

struct Edge
{
  int mV[2];
  bool mDoubled;

  Edge(int V[2], bool Doubled=false) 
    : mDoubled(Doubled)
  {
    mV[0]=V[0];
    mV[1]=V[1];
  }
};

enum { Reversed=0x10000000 };

struct Graph
{
  typedef instl vector<Vertex> VertexType;
  typedef instl vector<Edge>   EdgeType;
  typedef VertexType::iterator VertexIter;
  typedef EdgeType  ::iterator EdgeIter;
  VertexType mV;
  EdgeType   mE;
  int mMaxRType;
  bool Read(instl istream &infrom);
  void Output(instl ostream &outto);
  void CoverOutput(instl ostream &outto);

  int Head(int edge)
    { if (edge&Reversed) return mE[edge-Reversed].mV[0]; else return mE[edge].mV[1]; }
  int Tail(int edge)
    { if (edge&Reversed) return mE[edge-Reversed].mV[1]; else return mE[edge].mV[0]; }
  int RType(int vert)
    { return mV[vert].refinedtype; }
  int FindVert(string name)
    { int i;
      for (i=0; i<mV.size(); ++i)
        if (mV[i].mName==name)
          break;
      if (i>=mV.size())
        return -1;
      return i;
    }
};

class Gfunct
  {
protected:
    Graph *mGraph;
    int mMaxDegree;
    struct valuetype
      {
        int edge;
        int value;
        valuetype(int aEdge, int aValue) : edge(aEdge), value(aValue) { }
      };
    instl vector<valuetype> mValues;
    void AddEdge(int edge, int vertex, int refinedtype);

public:
    void Initialize(Graph *graph, int MaxRType);
    int operator()(int vertex, int edge);
    instl vector<int> mR;
  };
