#include <jstring.h>
#include <vector>
#include "findcover.h"
#include <assert.h>

void Gfunct :: Initialize(Graph *graph, int MaxRType)
  {
    mGraph=graph;
    mMaxDegree=0;
    int i;
    for (i=0; i<graph->mV.size(); ++i)
      mMaxDegree=instl max(mMaxDegree, graph->mV[i].degree);
    mValues.resize(mMaxDegree*graph->mV.size(), valuetype(-1,0));
    for (i=0; i<graph->mE.size(); ++i)
      {
        int vh=graph->mE[i].mV[0],
            vt=graph->mE[i].mV[1];
        int typeh=graph->mV[vh].refinedtype,
            typet=graph->mV[vt].refinedtype;
        assert(typeh>=0 && typeh<MaxRType);
        assert(typet>=0 && typet<MaxRType);
        AddEdge(i, vh, typet);
        AddEdge(i+Reversed, vt, typeh);
      }

    mR.resize(MaxRType*MaxRType,0);
    
    int index=0;
    for (i=0; i<graph->mV.size(); ++i)
      {
        instl vector<int> gvalues(MaxRType, 0);
        int j;
        for (j=0; j<mMaxDegree; ++j)
          {
            if (mValues[index].edge!=-1)
              {
                int rtype=mValues[index].value;
                mValues[index].value=gvalues[rtype];
                ++gvalues[rtype];
              }
            ++index;
          }
        for (j=0; j<MaxRType; ++j)
          mR[graph->RType(i)*MaxRType+j] = gvalues[j];
      }
  }

void Gfunct::AddEdge(int edge, int vertex, int refinedtype)
  {
    int pos=vertex*mMaxDegree;
    while (mValues[pos].edge!=-1)
      ++pos;
    assert(pos<(vertex+1)*mMaxDegree);
    mValues[pos].edge=edge;
    mValues[pos].value=refinedtype;
  }

int Gfunct :: operator()(int vertex, int edge)
  {
    int pos=vertex*mMaxDegree;
    while (mValues[pos].edge!=edge)
      ++pos;
    return mValues[pos].value;
  }
