#include <jstring.h>
#include <vector>
#include "findcover.h"
#include <jiostr.h>
#include <stdlib.h>
#include <jstrstr.h>

bool Graph :: Read(instl istream &infrom)
  {
    mMaxRType=0;
    while (infrom && !infrom.eof())
      {
        string s;
        if (! (infrom >> s))
          break;
        string t;
        instl getline(infrom, t);
        instl istringstream stream(WORKAROUND_OLDISTRSTREAM(t));

        if (s=="v")
          {
            Vertex v;
            if (!( stream >> v.mName)) return false;
            if (!( stream >> v.refinedtype)) return false;
            if (!( stream >> v.x)) return false;
            if (!( stream >> v.z)) return false;
            if (!( stream >> v.bringforward))
              v.bringforward=0;
            v.degree=0;
            mMaxRType=instl max(mMaxRType, v.refinedtype+1);
            mV.push_back(v);
          }
        else if (s=="e")
          {
            int v[2];
            string vname;
            int i;
            for (i=0; i<2; ++i)
              if (stream >> vname)
                {
                  v[i]=FindVert(vname);
                  if (v[i]<0)
                    return false;
                }
              else
                return false;
            int mult;
            if (!(stream >> mult))
              mult=1;

            Edge e(v);
            for (i=0; i<mult; ++i)
              mE.push_back(e);

            mV[v[0]].degree+=mult;
            mV[v[1]].degree+=mult;
          }
        else if (isalpha(s[0]))
          {
            cerr << "Unrecognized command " << s << endl;
            return false;
          }
      }
    return true;
  }

void Graph :: Output(instl ostream &out)
{
  for (VertexIter v=mV.begin();
       v!=mV.end();
       ++v)
    out << "v " << ((*v).mName) << ' '
         << (*v).x << ' '
         << (*v).z << ' '
         << (*v).bringforward << '\n';
  for (EdgeIter e=mE.begin();
       e!=mE.end();
       ++e)
    out << "e " 
         << (mV[(*e).mV[0]].mName) << ' '
         << (mV[(*e).mV[1]].mName) << '\n';
}

void Graph :: CoverOutput(instl ostream &out)
{
  for (VertexIter v=mV.begin();
       v!=mV.end();
       ++v)
    out << "v " << ((*v).mName) << '\n';
  for (EdgeIter e=mE.begin();
       e!=mE.end();
       ++e)
    out << "e " 
         << (mV[(*e).mV[0]].mName) << ' '
         << (mV[(*e).mV[1]].mName) << '\n';
}
